<?php

/**

 * Plugin Name: Tithe Envelope

 * Plugin URI: higherdesigns.net

 * Description: A mini tithe envelope to allow for Paypal donatinos with amounts specified for 'Tithes', 'Offering', and one fill in category.

 * Version: 1.0.0

 * Author: Scott Severt

 * Author URI: 

 * License: GPL2

 */





function titheScript() {

wp_register_script('tithe_e', plugins_url('tithe-envelope.js', __FILE__), array('jquery'),'1.1', false);

wp_enqueue_script('tithe_e');

}



function generateTitheEnvelope() { 

titheScript();

add_action( 'wp_enqueue_scripts', 'titheScript' );

$thisPage = current_page_url();

$titheEmail = get_option('email');

$titheDonation = get_option('donation');

$titheCode =  "<div id='titheEnvelope'>

<form action='https://www.paypal.com/cgi-bin/webscr' method='post' name='_xclick'>

<table id='offering'>

<tbody>

<tr>

<th>Designation</th>

<th>Amount</th>

</tr>

<tr>

<td>Tithes<input id='titheLabel1' name='on0' type='hidden' value='Tithes' /></td>

<td>$<input id='titheAmount1' name='os0' type='text' class='tithe-envelope-amount'/></td>

</tr>

<tr>

<td>General Offering<input id='titheLabel2' name='on1' type='hidden' value='Offering' /></td>

<td>$<input id='titheAmount2' name='os1' type='text' class='tithe-envelope-amount' /></td>

</tr>

<tr>

<td>Other <input id='titheLabel3' name='on2' type='text' value='' /></td>

<td>$<input id='titheAmount3' name='os2' type='text' class='tithe-envelope-amount' /></td>

</tr>

<tr>

<th>Total</th>

<th>$<input id='titheTotal' name='amount' type='text' class='tithe-envelope-amount' /></th>

</tr>

</tbody>

</table>



<input id='titheSubmit' type='submit' value='Donate' />

<span id='titheErrors'></span>

<input name='cmd' type='hidden' value='_donations' />

<input name='business' type='hidden' value='{$titheEmail}' />

<input name='item_name' type='hidden' value='{$titheDonation}' />

<input name='return' type='hidden' value='' />

<input name='no_note' type='hidden' value='0' />

<input name='cancel_return' type='hidden' value='{$thisPage}' />

<input name='currency_code' type='hidden' value='USD' />

</form></div>";

return $titheCode;

}

add_shortcode( "tithe-envelope", "generateTitheEnvelope");



//admin part

add_action( 'admin_menu', 'titheAdminMenu' );

function titheAdminMenu() {

	add_options_page( 'Tithe Envelope Settings', 'Tithe Envelope', 'manage_options', 'tithe_envelope_admin', 'titheAdminOptions' );

} 

function titheAdminOptions() {

	if ( !current_user_can( 'manage_options' ) )  {

		wp_die( __( 'You do not have sufficient permissions to access this page.' ) );

	}

	echo "<div class='wrap'>

		<h2>Tithe Envelope Settings</h2>



		<form  action='options.php' method='POST'>";

			settings_fields( 'tithe_envelope' );	//pass option group name

			do_settings_sections( 'tithe_envelope_admin' ); 	//pass slug name of page

			submit_button();

	echo "</form>

	</div>	";

	}

 add_action( 'admin_init', 'tithe_admin_init' );

 function tithe_admin_init() {

	register_setting( 'tithe_envelope', 'tithe_envelope', 'tithe_options_validate' ); 	 

	register_setting( 'tithe_envelope', 'email', 'tithe_options_validate' ); 	 

	register_setting( 'tithe_envelope', 'donation', 'tithe_options_validate' ); 	 

	add_settings_section('tithe_instructions','Instructions','instructions_callback_function','tithe_envelope_admin');

	add_settings_section('tithe_settings','Settings','settings_callback_function','tithe_envelope_admin');

	add_settings_field('paypal_email','Paypal Email','email_callback_function','tithe_envelope_admin','tithe_settings');

	add_settings_field('donation_name','Donation Name','donation_callback_function','tithe_envelope_admin','tithe_settings');

 } 

  function instructions_callback_function() {

 	echo '<p>Simply use the shortcode [tithe-envelope] in any page, post, or widget to insert a mini tithe envelope and donate button to your website.</p>';

 }

 function settings_callback_function() {

 	echo '<p>Enter the email address registered for your church\'s PayPal account as well of the description you want displayed as the name of the donation.</p>';

 }

 

 function email_callback_function() {

	 $options = get_option('email');

	 echo "<input id='paypal_email' name='email' size='40' type='text' value='{$options}' />";

 } 

 function donation_callback_function() { 

	 $options = get_option('donation');

	 echo "<input id='donation_name' name='donation' size='40' type='text' value='{$options}' />";

 }

 

function tithe_options_validate($input) {

	return $input;

}

///////////////////////////////////////////////////////////////////////////////////////////////////

//extra

function current_page_url() {

	$pageURL = 'http';

	if( isset($_SERVER["HTTPS"]) ) {

		if ($_SERVER["HTTPS"] == "on") {$pageURL .= "s";}

	}

	$pageURL .= "://";

	if ($_SERVER["SERVER_PORT"] != "80") {

		$pageURL .= $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"].$_SERVER["REQUEST_URI"];

	} else {

		$pageURL .= $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];

	}

	return $pageURL;

}

?>